unit tve1;

interface

uses
  ComObj,

  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Spin, ComCtrls;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Panel3: TPanel;
    SpeedButton1: TSpeedButton;
    Edit_ExcelName: TEdit;
    Panel1: TPanel;
    Label_YesConnect: TLabel;
    Label1: TLabel;
    SE_ListNum: TSpinEdit;
    Label_ListName: TLabel;
    Panel4: TPanel;
    Panel5: TPanel;
    SpeedButton2: TSpeedButton;
    TreeView1: TTreeView;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SE_ListNumChange(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Excel : Variant;
  end;

var
  Form1: TForm1;


// Excel   OLE Automation
function ExecExcel(sExcelName : string;YesVisible,YesAddWorkBooks : boolean) : Variant;
//,    (HandleAny)
function YesLinkToVariant(HandleAny : Variant) : boolean;
//    Excel   
function GetListExcel(Excel : Variant; NumList : integer) : Variant;
//     
function Excel_GetNameList(Excel : Variant; NumList : integer) : string;
//      Excel
function PutToCellInExcel(ListExcel : Variant;NRow,NCol,YesBold,YesBorder : integer; Value : string) : boolean;

//,       Excel
function Tree_CopyToExcel(sHead : string; ListExcel : Variant; ListTree : TTreeView) : integer;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit_ExcelName.Text:='Excel.Application';
  Excel:=UnAssigned;
  Label_YesConnect.Visible:=false;
  Label_ListName.Caption:='';
  TreeView1.FullExpand;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=true;
  if YesLinkToVariant(Excel) then begin
     Excel.Quit;
  end;
  Excel:=UnAssigned;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
// Excel   OLE Automation
begin
  if YesLinkToVariant(Excel) then begin
     // Excel    -  
     Excel.Quit;
  end;
  Excel:=UnAssigned;
  Label_YesConnect.Visible:=false;
  Label_ListName.Caption:='';

  // Excel
  Excel:=ExecExcel(Edit_ExcelName.Text,true,true);
  if YesLinkToVariant(Excel) then begin
     //   Excel
     Label_YesConnect.Visible:=true;

     //  
     Label_ListName.Caption:=Excel_GetNameList(Excel,SE_ListNum.Value);

     //     Excel
     Excel.DisplayAlerts := true;
  end
  else begin
     //   Excel
     ShowMessage(' ');
  end;
end;


procedure TForm1.SE_ListNumChange(Sender: TObject);
begin
  Label_ListName.Caption:='';
  if length(SE_ListNum.Text)>0 then begin
     //  
     Label_ListName.Caption:=Excel_GetNameList(Excel,SE_ListNum.Value);
  end;
end;


procedure TForm1.SpeedButton2Click(Sender: TObject);
Var
  ListExcel : Variant;
begin
  //    Excel
  if YesLinkToVariant(Excel) then begin
     //    Excel    
     ListExcel:=GetListExcel(Excel,SE_ListNum.Value);
     //     Excel
     if YesLinkToVariant(ListExcel) then begin
        // ""   Excel
        Tree_CopyToExcel('  TTreeView  Excel (http://doc-prg.narod.ru/art_00902/art_00902.htm)',
                         ListExcel,
                         TreeView1);
     end
     else begin
        //      Excel
        ShowMessage('     N '+SE_ListNum.Text+' !');
     end;
  end
  else begin
     //   Excel
     ShowMessage('    Excel ...');
  end;
end;



//******************************************************
function Tree_CopyToExcel(sHead : string; ListExcel : Variant; ListTree : TTreeView) : integer;
//,       Excel
//sHead    -  ( )
//ListExcel -    Excel (   "")
//ListTree -  TTreeView
//  - -   ()
//(c) Sergey Popov, Usinsk, Komi
Var
  Lev,MaxLevel,iLev,
  NumLine, NumCol,NumLineLast,NumLineFirst,
  i123,j,i,k : integer;
begin
  Result:=0;
  if ListTree<>NIL then begin
     //     Excel
     if YesLinkToVariant(ListExcel) then begin

        sHead:=Trim(sHead);
        MaxLevel:=0;
        NumLine:=1;
        NumCol:=1;

        //--------------------
        //  
        ListExcel.Cells[NumLine,NumCol].Value := #39+'Date : '+DateTimeToStr(NOW);
        //--------------------

        NumLine:=NumLine+1;
        if Length(sHead)>0 then begin
           //--------------------
           // 
           NumLine:=NumLine+1;
           PutToCellInExcel(ListExcel,NumLine,NumCol,1,0,#39+sHead);
           NumLine:=NumLine+1;
           //--------------------
        end;
        Result:=NumLine;
        NumLineFirst:=0;
        NumLineLast:=0;
        MaxLevel:=0;
        if ListTree.Items.Count>0 then begin
           //--------------------
           // 
           i:=-1;
           while i<(ListTree.Items.Count-1) do
            begin
              i:=i+1;
              Lev:=ListTree.Items[i].Level;
              NumCol:=Lev+1;
              if MaxLevel < Lev then MaxLevel := Lev;
              NumLine:=NumLine+1;
              if i=0 then NumLineFirst:=NumLine;
              ListExcel.Cells[NumLine,NumCol].Value := #39+ListTree.Items[i].Text;
              ListExcel.Cells[NumLine,NumCol].Borders[4].LineStyle:=3; //1
              Application.ProcessMessages;
           end;
           //--------------------

           NumLineLast:=NumLine;
           Result:=NumLine;
           MaxLevel:=MaxLevel+1;

           //--------------------
           //     2 (  )
           for i:=1 to MaxLevel do
            begin
              ListExcel.Columns[i].ColumnWidth := 2;
           end;
           //--------------------

           //--------------------
           //    ( )
           i123:=0;
           i:=NumLineFirst;
           while i<NumLineLast do
            begin
              i:=i+1;
              i123:=i123+1;
              j:=1;
              while j<MaxLevel do
               begin
                 j:=j+1;
                 if Length(Trim(ListExcel.Cells[i,j].Value))>0 then begin
                    k:=i+1;
                    while k>1 do
                     begin
                       k:=k-1;
                       if Length(Trim(ListExcel.Cells[k,j-1].Value))<=0 then begin
                          ListExcel.Cells[k,j].Borders[1].LineStyle:=3;
                       end
                       else begin
                          k:=-1;
                       end;
                    end;
                    j:=MaxLevel+1;
                 end;
              end;
              Application.ProcessMessages;
           end;
           //--------------------

        end;
     end;
  end;
end;
//******************************************************


//******************************************************
function PutToCellInExcel(ListExcel : Variant;NRow,NCol,YesBold,YesBorder : integer; Value : string) : boolean;
//      Excel
Var
 kkk : integer;
begin
  Result:=FALSE;
  if YesLinkToVariant(ListExcel) then begin
     Result:=TRUE;
     ListExcel.Cells[NRow,NCol].Value := Trim(Value);
     ListExcel.Cells[NRow,NCol].Font.Bold:=YesBold;
     if YesBorder>0 then begin
        for kkk:=1 to 4 do
         begin
          ListExcel.Cells[NRow,NCol].Borders[kkk].LineStyle:=1;
          ListExcel.Cells[NRow,NCol].Borders[kkk].Weight := 2;
        end;
     end;
  end;
end;
//******************************************************

//******************************************************
function ExecExcel(sExcelName : string;YesVisible,YesAddWorkBooks : boolean) : Variant;
// Excel   OLE Automation
//sNameExcel -  Excel,  OLE Automation 
//YesVisible -    Excel
//YesAddWorkBooks -   
// OLE-  Excel
begin
  Result := UnAssigned;
  sExcelName:=Trim(sExcelName);
  if length(sExcelName)<=0 then sExcelName:='Excel.Application';
  // Excel
  Result:=CreateOleObject(sExcelName);
  //  
  if not VarIsEmpty(Result) then begin
     //  Excel
     Result.Visible:=YesVisible;
     if YesAddWorkBooks then begin
        //  
        Result.Workbooks.Add();
     end;
  end;
end;
//******************************************************


//******************************************************
function YesLinkToVariant(HandleAny : Variant) : boolean;
//,    (HandleAny)
begin
 Result:=FALSE;
 if not VarIsEmpty(HandleAny) then Result:=TRUE;
end;
//******************************************************



//******************************************************
function GetListExcel(Excel : Variant; NumList : integer) : Variant;
//    Excel   
begin
  Result:=UnAssigned;
  if YesLinkToVariant(Excel) then begin
     if (NumList>0) and  (NumList<=Excel.ActiveWorkBook.WorkSheets.Count) then begin
        Result:=Excel.ActiveWorkBook.WorkSheets[NumList];
     end;
  end;
end;
//******************************************************


//******************************************************
function Excel_GetNameList(Excel : Variant; NumList : integer) : string;
//     
begin
  Result:='';
  if YesLinkToVariant(Excel) then begin
     if NumList>0 then begin
        if NumList<=Excel.WorkSheets.Count then begin
           Result:=Trim(Excel.ActiveWorkbook.WorkSheets[NumList].Name);
        end;
     end;
  end;
end;
//******************************************************





end.




